#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
#use CGI::Carp qw(fatalsToBrowser);
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}



##################################################################################

sub start
{

$headingd = acs::get_heading_box("$web_url/add.gif", "Directory Tree + Statistics", qq[Click here to <a href="javascript:onClick=window.close()">close</a> this window.]);


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
$sth = $dbh->prepare("SELECT * FROM dirs");
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: SELECT * FROM dirs";}

$rows = $sth->rows();

print <<ENDOFT;

$headingd
<html>
<head>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />
<title></title>
</head>
<body>

<p class="normaltext">

<img src="$web_url/subdir.gif"> <b>Root</b>

ENDOFT

$acnt = 0;
$total_links = 0;

while ( @row = $sth->fetchrow() )
	{
	
	if ($row[2] ne "") {$dirstring = $row[2];}
	if ($row[3] ne "") {$dirstring = $dirstring . "/$row[3]";}
	if ($row[4] ne "") {$dirstring = $dirstring . "/$row[4]";}
	if ($row[5] ne "") {$dirstring = $dirstring . "/$row[5]";}
	if ($row[6] ne "") {$dirstring = $dirstring . "/$row[6]";}
	if ($row[7] ne "") {$dirstring = $dirstring . "/$row[7]";}
	if ($row[8] ne "") {$dirstring = $dirstring . "/$row[8]";}
	if ($row[9] ne "") {$dirstring = $dirstring . "/$row[9]";}
	if ($row[10] ne "") {$dirstring = $dirstring . "/$row[10]";}
	if ($row[11] ne "") {$dirstring = $dirstring . "/$row[11]";}
	if ($row[12] ne "") {$dirstring = $dirstring . "/$row[12]";}
	if ($row[13] ne "") {$dirstring = $dirstring . "/$row[13]";}
	if ($row[14] ne "") {$dirstring = $dirstring . "/$row[14]";}
	if ($row[15] ne "") {$dirstring = $dirstring . "/$row[15]";}
	if ($row[16] ne "") {$dirstring = $dirstring . "/$row[16]";}
	if ($row[17] ne "") {$dirstring = $dirstring . "/$row[17]";}

	$atree[$acnt] = $dirstring . "\t" . 
						 $row[0] . "\t" .  #### CID
						 $row[1] . "\t" .  #### LEVEL
						 $row[28]; #### NAME
	$acnt++;
	
	if ($row[1] == 1) { $total_links = $total_links + $row[20]; }
	
	}


@atree = sort(@atree);

foreach $item (@atree)
	{
	($dirstr, $cid, $level, $name) = split (/\t/, $item);

	$spacing = "";
	for ($ms = 0; $ms < ($level + 1); $ms++) 
			{
			$spacing = $spacing . "&nbsp; &nbsp; ";
			}
	
	$name = $spacing . "<img src=\"$web_url/subdir.gif\"> $name (ID=$cid)";
	if ($level == 1) { $name = "<br><b>$name</b>";}
	print "$name<br>";
	}

$sth->finish;
$dbh->disconnect;

print "<br><Br>Total Directories/Categories: <b>$rows</b></p></body></html>";

}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

